import { PrimaryKeyProp, defineEntity, p } from '@mikro-orm/core';

export class IcrWords {
  [PrimaryKeyProp]?: 'Id';
  Id!: bigint;
  StudentId!: bigint;
  CategoryId!: bigint;
  BookId!: bigint;
  ArticleId!: bigint;
  Content?: string;
  RecordTime!: Date;
  Type!: number;
  Revision!: number;
  CreatedBy?: bigint;
  CreatedTime!: Date;
  UpdatedBy?: bigint;
  UpdatedTime?: Date;
  IsDeleted!: unknown;
}

export const IcrWordsSchema = defineEntity({
  class: IcrWords,
  properties: {
    Id: p.bigint().primary().name('Id').unsigned(false).autoincrement(false).comment('主键Id'),
    StudentId: p.bigint().name('StudentId').comment('学生Id'),
    CategoryId: p.bigint().name('CategoryId').comment('分类ID'),
    BookId: p.bigint().name('BookId').comment('书籍Id'),
    ArticleId: p.bigint().name('ArticleId').comment('文章Id'),
    Content: p.string().name('Content').nullable().comment('内容'),
    RecordTime: p.datetime().name('RecordTime').length(3).comment('记录时间'),
    Type: p.integer().name('Type').comment('类型(1-批注 2-积累)'),
    Revision: p.integer().name('Revision').comment('乐观锁'),
    CreatedBy: p.bigint().name('CreatedBy').nullable().comment('创建者用户Id'),
    CreatedTime: p.datetime().name('CreatedTime').length(3).comment('创建时间'),
    UpdatedBy: p.bigint().name('UpdatedBy').nullable().comment('修改者用户Id'),
    UpdatedTime: p.datetime().name('UpdatedTime').length(3).nullable().comment('修改时间'),
    IsDeleted: p.array().name('IsDeleted').comment('是否删除'),
  },
});
